<template lang="pug">
	form(@submit.prevent="handleSearchTerms(searchTerms)")
		label
			span Search
			input(
				v-model="searchTerms",
				type="text",
				:placeholder="site.searchPlaceholderText",
				autofocus,
				aria-label="Search for a film"
			)
</template>

<script>
	import debounce from 'debounce';
	import site from '~/globals/site';

	const DEBOUNCE_TIMEOUT = 500;

	export default {
		name: 'SearchForm',
		data () {
			return { site };
		},
		computed: {
			searchTerms: {
				get () { return this.$store.state.searchTerms || ''; },
				set (val) { return this.$store.commit('setSearchTerms', val); }
			}
		},
		watch: {
			searchTerms (val) {
				if (val === '' && this.$route.path !== '/home') {
					this.$router.push('/');

					return;
				}

				this.debouncedHandleSearchTerms(val);
			}
		},
		created () {
			this.debouncedHandleSearchTerms = debounce(this.handleSearchTerms, DEBOUNCE_TIMEOUT);
		},
		methods: {
			handleSearchTerms (terms) {
				if (terms === '') return this.$router.push('/');

				const expectedPath = `/search-results/${terms}`;
				if (this.$route.path !== expectedPath) return this.$router.push(expectedPath);

				return null;
			}
		}
	};
</script>

<style lang="scss" scoped>
	@import "~/scss/variables";

	form {
		text-align: center;

		label {

			span { display: none; }

			input {
				font-size: 1rem;
				width: calc(100% - 3rem);
				max-width: 53rem;
				margin: 0 auto 2rem;
				background-color: transparent;
				border: none;
				border-bottom: 0.125rem solid $fgFaded;
				border-radius: 0;
				box-shadow: none;
				padding: 0.5rem;
				color: $fg;

				&::-moz-placeholder,
				&::-webkit-input-placeholder,
				:-ms-input-placeholder {
					color: $fgFaded;
					opacity: 0.25;
				}

				&:focus {
					border-bottom: 0.125rem solid $teal;
					box-shadow: 0 0.125rem 0 0 $teal;
					outline: none;
				}

				&:-webkit-autofill { -webkit-box-shadow: 0 0 0 1.5rem $fg inset; }
			}
		}
	}
</style>
